module CYCSRS.Processors.Combinations where
import CYCSRS.Processor
import CYCSRS.Processors.MatrixInterpretator as M
import CYCSRS.Processors.Torpacyc as T
import CYCSRS.Processors.AProVE as A 
import CYCSRS.Processors.TTT2 as TTT2 
import CYCSRS.Processors.Encoders.Split as S
import CYCSRS.Processors.Cycnt as N


default_processor :: Processor
default_processor = combine_sequence [(T.processor,40),(N.processor,10),(A.processor,6),(split_processor,42)]

default_long_processor :: Processor
default_long_processor = combine_sequence [(T.processor,20),(M.processor,20),(N.processor,10),(A.processor,6),(split_processor,22),(TTT2.processor,22)]

comb_processor :: Processor
comb_processor = combine M.processor (combine N.processor split_processor 10) 40

comb1_processor :: Processor
comb1_processor = combine N.processor (combine M.processor N.processor 90) 10

-- nonterm_processor = combine N.processor A.processor 50


split_processor = 
 (combine S.processor A.processor 0) {
    properties = PProperties {cycletermination =  True,
                              cyclenontermination=True,
                              transformator = False,
                              description="Apply Split-Transformation then run AProVE"}
 }


transform_and_aprove transformation = 
 (combine transformation A.processor 0) {
    properties = PProperties {cycletermination =  True,
                              cyclenontermination=True,
                              transformator = False,
                              description="Apply transformation then run AProVE"}
 }
  
transform_and_ttt2 transformation = 
 (combine transformation TTT2.processor 0) {
    properties = PProperties {cycletermination =  True,
                              cyclenontermination=True,
                              transformator = False,
                              description="Apply transformation then run ttt2"}
 }
  
