module CYCSRS.Processors.Torpacyc where
import CYCSRS.Processor
import CYCSRS.Types
import CYCSRS.Util.System
import Data.List
import System.IO
import System.Exit
import System.Environment
import System.Process
import System.Directory
import CYCSRS.CallsParam
import Control.Exception


processor = 
 Processor {
    properties = PProperties {cycletermination = True,
                              cyclenontermination=False,
                              transformator=False,
                              description="Wrapper for Torpacyc"},
    run = runTorpacyc}
  where
        runTorpacyc procinput 
         | Just _ <- weakproblem procinput = return 
                                            (POutput {proof =  "PROCESSOR: Torpacyc\n skip - unable to prove relative termination"
                                                      ,result = MAYBE
                                                      ,outputproblem = inputproblem procinput
                                                      ,outputweakproblem = weakproblem procinput})
         | Nothing <- weakproblem procinput =
         do
           let o = options procinput
           let maybetimeout = timeout o
           let srs = inputproblem procinput
           inputfile <- getFreshSRSFile
           err <- getErrFile
           removeSRSFile      
           writeFile inputfile (showSRS srs)
           mkCallTorpacyc maybetimeout
           tmpfile    <- getTempFile
           resultfile <- getOutFile
           removeOUTFile tmpfile        
           let cmd = torpacyc ++ " < " ++ inputfile ++ " > " ++ tmpfile ++ " 2> " ++ err
           x <- runCommand  cmd
           ecode <- waitForProcess x
           ok <- doesFileExist "srs"
           if ok then do 
                    c <- strictReadFile "srs"
                    let answer = if "YES" `isPrefixOf` c then YES else MAYBE
                    theproof  <- strictReadFile tmpfile
                    case answer of
                     YES -> return (POutput {proof = theproof, result = answer, outputproblem = [], outputweakproblem=Nothing})
                     _   -> do 
                             tmpsrsfile <- getFreshSRSFile
                             system ("cp " ++ "srs " ++ tmpsrsfile)
                             outsrs <- catch (getSRS tmpsrsfile) ((\x -> return srs)::((SomeException) -> IO SRS))
                             deleteTMPFiles
                             return (POutput {proof = "PROCESSOR: Torpacyc\n"++theproof, result = answer, outputproblem = if null outsrs then srs else outsrs,
                                              outputweakproblem = Nothing})
            else do
                             deleteTMPFiles
                             return (POutput {proof = "PROCESSOR: Torpacyc\n", result = OTHER "Crashed", outputproblem = srs, outputweakproblem = Nothing})

        torpacyc  = "./call_torpacyc.sh"

